package com.ddabadi.stock.model;

import com.ddabadi.stock.model.base.Base;
import com.ddabadi.stock.model.enumerate.TransStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.ToString;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Entity
@Data
@NoArgsConstructor
@EqualsAndHashCode
@ToString
@Table(name="sales_hd", schema = "public")
public class SalesHd extends Base implements Serializable {

    @Id
    @SequenceGenerator(name = "pk_sales_hd_seq", sequenceName = "sales_hd_seq", allocationSize=1)
    @GeneratedValue( strategy = GenerationType.SEQUENCE, generator="pk_sales_hd_seq")
    private String id;

    // Generated by System
    // FTyyMM9999
    // FT -> system parameter
    @Column(length = 10)
    private String invoiceNumber;

    @ManyToOne
    @JoinColumn(name = "sales_customer")
    private Customer customer;

    @ManyToOne
    @JoinColumn(name = "sales_salesman")
    private Salesman salesman;

    @Temporal(TemporalType.DATE)
    @Column
    private Date transactionDate;

    @Column(length = 250, nullable = false)
    private String description;

    @Column
    private TransStatus status;

    @Column
    private BigDecimal subTotal;

    @Column
    private BigDecimal disc;

    @Column
    private BigDecimal ppn;

    @Column
    private BigDecimal grandTotal;

}
